#include "stdafx.h"

using namespace std;


#include "../../Kernel/kernelincludes.h"
#include "RekonObj.h"
#include "RekBunka.h"
#include "RekonBunkaSeznam.h"
#include "Hradlo.h"


	Hradlo::Hradlo(){
		nalezeneRekonvergence =NULL;
		rekonverg=NULL;
		tmp=0;
		this->oname="";
		this->ohradlo=NULL;
		this->ihradlo=NULL;
		this->pozorCOPVstupu=NULL;
		this->pozorCOPVystupu=-1;
		this->inames=NULL;
	}

	Hradlo::Hradlo( int level, HType typ){
		nalezeneRekonvergence =NULL;
		rekonverg=NULL;
		tmp=0;
		this->iport=-1;
		this->oname="";
		this->level=level;
		this->icount=icount;
		this->typ=typ;
		this->ihradlo= new vector<Hradlo * >();
		this->ohradlo= NULL;
		this->pozorCOPVstupu=NULL;
		this->pozorCOPVystupu=-1;
		this->inames=NULL;

		
	}
	Hradlo::Hradlo(int iport){ //pro navazani vstupu
		nalezeneRekonvergence =NULL;
		
		tmp=0;
		this->oname="";
		this->level=0;
		this->riditelnostCOP=0.5;
		this->iport=iport;
		this->ohradlo=NULL;
		this->ihradlo=NULL;
		this->pozorCOPVstupu=NULL;
		this->pozorCOPVystupu=-1;
		this->inames=NULL;
		rekonverg=NULL;
	}

	Hradlo::Hradlo(Hradlo * vystup){
		nalezeneRekonvergence=NULL;
		rekonverg=NULL;
		tmp=0;
		this->oname=vystup->getoname();
		this->level=-1;
		this->ohradlo=NULL;
		this->ihradlo=new vector<Hradlo *>();
		this->ihradlo->push_back(vystup);
		this->pozorCOPVstupu=NULL;
		this->pozorCOPVystupu=1;
		this->inames=NULL;


	}
	void Hradlo::setLevel(int level){
		this->level=level;
	}
	void Hradlo::setOName(string oname){
		this->oname=oname;
	}
	void Hradlo::setType(HType typ){
		this->typ=typ;
	}

	void Hradlo::setPokryti(bitvector bit){
		this->pokryti=bit;	
	}

	int Hradlo::geticount(){
		return this->icount;
		
	}
	int Hradlo::getiport(){
		return iport;
	}
	vector<Hradlo *> * Hradlo::getihradlo(){
		return this->ihradlo;
	}
	string Hradlo::getoname(){
		return this->oname;
	}

	vector<Hradlo * > * Hradlo::getohradlo(){
		return this->ohradlo;
	}



	bitvector Hradlo::getPokryti(){
		return pokryti;
	}

	int Hradlo::getLevel(){
		return level;
	}
	HType Hradlo::getType(){

		return typ;
	}
	double Hradlo::getRiditelnostCOP(){
		return this->riditelnostCOP;
	}
	void Hradlo::pushiHradlo(Hradlo* h){
		if(ihradlo==NULL){
			this->ihradlo=  new vector<Hradlo * >();
		}
		this->ihradlo->push_back(h);
		this->icount=ihradlo->size();
	}
	void Hradlo::pushoHradlo(Hradlo* h){
		if(ohradlo==NULL){
			this->ohradlo=  new vector<Hradlo * >();
		}

		this->ohradlo->push_back(h);
	}
	void Hradlo::eraseihradlo(unsigned int index ){
		if(ihradlo->size()>index){
			ihradlo->erase(ihradlo->begin()+index);
			
		}
		this->icount=ihradlo->size();
	}
	void Hradlo::eraseihradlo(Hradlo * h){
		for(unsigned int i=0; i<ihradlo->size();i++){
			if(ihradlo->at(i)==h){
				ihradlo->erase(ihradlo->begin()+i);
				this->icount=ihradlo->size();
				return;
			}
		}
		return;
	}

	void Hradlo::eraseohradlo(unsigned int index ){
		if( ohradlo->size()>index){
			ohradlo->erase(ohradlo->begin()+index);
		}
	}
	void Hradlo::eraseohradlo(Hradlo * h){
		for(unsigned int i=0; i<ohradlo->size();i++){
			if(ohradlo->at(i)==h){
				ohradlo->erase(ohradlo->begin()+i);
				return;
			}
		}
		return;
	}


	double Hradlo::getPozorovatelnostCOPVystupu(){
		return pozorCOPVystupu;
	}
	double Hradlo::getPozorovatelnostCOPVstupu(int index){
		return pozorCOPVstupu->at(index);
	}
	void Hradlo::vypoctiPozorovatelnostCOP(){//hradlo patri do obvodu a ma jmeno


		double maximum;
		double poz;
		//nastavim pozorovatelnost vystupu z hradla, pred vetvenim
		if(ohradlo==NULL){//vystuni hradlo;
			if(level==-1){//zastupne vystupni hradlo
				ihradlo->at(0)->pozorCOPVystupu=1;
			}else{
				pozorCOPVystupu=1;
			}
		}else{
			if(pozorCOPVystupu==-1){	//nebylo nastaveno zastupnym hradlem
				maximum=-1;
				for(unsigned int i=0; i<ohradlo->size();i++){
					maximum=max(maximum,ohradlo->at(i)->getPozorovatelnostCOPVstupu(ohradlo->at(i)->getiindex(oname)));
				}
				pozorCOPVystupu=maximum;
			}
		}
		if(level==0||level==-1){return;}//jedna se o vstup nebp zastupny vystup
		pozorCOPVstupu=new vector<double>();
		//nastavim pozorovatelnost vstupu za vetvenim
		//pro vsechny vstupy
			for(unsigned int i=0; i<ihradlo->size();i++){
				poz=pozorCOPVystupu;
				for(unsigned int j=0; j<ihradlo->size();j++){
					if(j==i){continue;}
					 switch(typ){//vypocitam pozorovatelnostCOP
						   case INV: //nic
							   break;
						   case NXOR:
						   case XOR:
							    poz=poz*max(ihradlo->at(j)->getRiditelnostCOP(),1-ihradlo->at(j)->getRiditelnostCOP());
							   break;
						   case NAND:
						   case AND:
							   poz=poz*ihradlo->at(j)->getRiditelnostCOP();
							   break;
						   case NOR:
						   case OR:
							    poz=poz*(1-ihradlo->at(j)->getRiditelnostCOP());
							   break;
						   default:
							   cout<<"Chyba vypocet pozCOP"<<endl;
							break;
					  }			
				}
				pozorCOPVstupu->push_back(poz);
		}

	}

	void Hradlo::vypoctiRiditelnostCOP(){
		double pozCOP=0;
		Hradlo *ihr;
		for(int j=0;j<this->icount;j++){
			ihr = ihradlo->at(j);
			  switch(typ){//vypocitam pozorovatelnostCOP
					   case INV: 
						   this->riditelnostCOP=1-ihr->getRiditelnostCOP();
						   break;
					   case XOR:
						   if(j==0){pozCOP=ihr->getRiditelnostCOP();}
						   else {this->riditelnostCOP=pozCOP*(1-ihr->getRiditelnostCOP())+ihr->getRiditelnostCOP()*(1-pozCOP);}
						   break;
					   case NXOR:
						   if(j==0){pozCOP=ihr->getRiditelnostCOP();}
						   else {this->riditelnostCOP=pozCOP*(1-ihr->getRiditelnostCOP())+ihr->getRiditelnostCOP()*(1-pozCOP);}
						   if(j==icount-1){this->riditelnostCOP=1-this->riditelnostCOP;}
						   break;
					   case AND:
					   
						   if(j==0){pozCOP=1;}
						   pozCOP=pozCOP*ihr->getRiditelnostCOP();
						    if(j==icount-1){this->riditelnostCOP=pozCOP;}
						   break;
					   case OR:
						   if(j==0){pozCOP=1;}
						   pozCOP=pozCOP*(1-ihr->getRiditelnostCOP());
						   if(j==icount-1){this->riditelnostCOP=1-pozCOP;}
						   break;

					   case NAND:
						   if(j==0){pozCOP=1;}
						   pozCOP=pozCOP*ihr->getRiditelnostCOP();
						   if(j==icount-1){this->riditelnostCOP=1-pozCOP;}
						   break;
					   case NOR:
						   if(j==0){pozCOP=1;}
						   pozCOP=pozCOP*(1-ihr->getRiditelnostCOP());
						   if(j==icount-1){
							   pozCOP=1-pozCOP;
							   this->riditelnostCOP=1-pozCOP;
						   }
						   break;
					   default:
						   cout<<"Chyba vypocet riditelnostCOP"<<(int)typ<<endl;
					    break;
				  }
		}
	}

	bool Hradlo::existujeJinyVstupZMinuleUrovneNez(int indexihradla){
		if(ihradlo==NULL) return false;
		for(unsigned int i=0; i<ihradlo->size();i++){
			if((int)i==indexihradla){
				continue;
			}
			if(ihradlo->at(i)->getLevel()==this->getLevel()-1){
				return true;
			}
		}
		return false;
	}

	bool Hradlo::existujeJinyVstupZMinuleUrovneNez(Hradlo * ihr){
		if(ihradlo==NULL) return false;
		for(unsigned int i=0; i<ihradlo->size();i++){
			if(ihradlo->at(i)==ihr){
				continue;
			}
			if(ihradlo->at(i)->getLevel()==this->getLevel()-1){
				return true;
			}
		}
		return false;

	}


	bool Hradlo::jeDuplicitniVstup(Hradlo* hr){
		for(unsigned int i=0; i<ihradlo->size();i++){
			if(hr==ihradlo->at(i))return true;
		}
		return false;

	}
	int Hradlo::getiindex(string name){// zeptam se, jaky jsem ja u tebe index?
		for(unsigned int i=0; i<ihradlo->size();i++){
			if(ihradlo->at(i)->getoname()==name){
				return i;
			}
		}
		return -1;
	}

	int Hradlo::getiindex(Hradlo * hradlo){// zeptam se, jakz jsem ja u tebe index?
		for(unsigned int i=0; i<ihradlo->size();i++){
			if(ihradlo->at(i)==hradlo){
				return i;
			}
		}
		return -1;
	}	
	vector<string>* Hradlo::getinames(){
		if(inames==NULL){
			inames=new vector<string>();
		}
		this->inames->clear();
		if(ihradlo==NULL){return NULL;};
		for(int i=ihradlo->size()-1; i>=0;i--){
			this->inames->push_back(ihradlo->at(i)->getoname());
		}
		return this->inames;
	}


	void Hradlo::vypoctiRekonvergenci(int pocetvstupu, int poceturovni){
		if(level==0){// nejde pouzit na vstupy, ale musi se nastavit rekonvergence
			rekonverg = new RekonBunkaSeznam(pocetvstupu,this,poceturovni);
			return;
		} 
		delete rekonverg;
		rekonverg=new RekonBunkaSeznam(pocetvstupu, poceturovni);
		if(nalezeneRekonvergence==NULL){
			nalezeneRekonvergence =new list<RekonObj *>();
		}else{
			for (list<RekonObj *>::iterator it=nalezeneRekonvergence->begin(); it!=nalezeneRekonvergence->end(); ++it){
				 delete (*it);
			 }
			nalezeneRekonvergence->clear();
		}
		
		//tady kazdy vstup s kazdym
		for(unsigned int i=0; i<this->getihradlo()->size();i++){
			for(unsigned int j=i+1; j<this->getihradlo()->size();j++){
				rekonverg->porovnej(this->getihradlo()->at(i)->rekonverg,this->getihradlo()->at(j)->rekonverg,this,nalezeneRekonvergence);
			}
		}




		//na konec.

		for(unsigned int i=0; i<this->getihradlo()->size();i++){
			rekonverg->slouci(this->getihradlo()->at(i)->rekonverg);
		}
		rekonverg->pridatHradlo(this);

	}


	list<RekonObj *> *  Hradlo::getRekonvergence(){
		return nalezeneRekonvergence;
	}

	void Hradlo::getRokonvergenceVector(vector < vector <RekonObj *> > * v){
		vector <RekonObj *> a;
		if(nalezeneRekonvergence==NULL){return;}
		for (list<RekonObj *>::iterator it=nalezeneRekonvergence->begin(); it!=nalezeneRekonvergence->end(); ++it){
				while((int)(v->size()-1)< (int)(*it)->rsize()){
					v->push_back(a);
				}
				v->at((*it)->rsize()).push_back((*it));
	

			}
	}


	 Hradlo::~Hradlo(void){
		 delete this->ihradlo;
		 delete this->pozorCOPVstupu;
		 delete this->ohradlo;
		 delete this->inames;
		 delete this->rekonverg;
		if(nalezeneRekonvergence!=NULL){ 
			for (list<RekonObj *>::iterator it=nalezeneRekonvergence->begin(); it!=nalezeneRekonvergence->end(); ++it){
				 delete (*it);
			 }
			delete nalezeneRekonvergence;
		}

	}

