	#include "stdafx.h"

using namespace std;
#include "../../Kernel/kernelincludes.h"

#include "Hradlo.h"
#include "RekonObj.h"
#include "RekBunka.h"


    RekBunka::RekBunka(){

	}
	RekBunka::RekBunka(const RekBunka & druhy){
		this->linie=druhy.linie;
	}
	RekBunka::RekBunka(int poceturovni){
		set<Hradlo*> s;
		for (int i=0;i<=poceturovni;i++){
			linie.push_back(s);
		}
	}
	RekBunka::RekBunka(int poceturovni, Hradlo * vstup){
		set<Hradlo*> s;
		linie.clear();
		for (int i=0;i<=poceturovni;i++){
			linie.push_back(s);
		}
		linie[0].insert(vstup);
	}
	bool RekBunka::stejneSet(set<Hradlo*>  * a,set<Hradlo*> * b){
		if(a->size()!=b->size())return false;
		set<Hradlo *>::iterator itb;
		itb=b->begin();
		for(set<Hradlo *>::iterator it=a->begin();it!=a->end();it++){
			if((*it)!=(*itb))return false;
			itb++;
		}
		return true;
	}


	set<Hradlo *> RekBunka::soucetSet (set<Hradlo*>  * a,set<Hradlo*> * b){
		set<Hradlo *> x;
		x=(*a);
		x.insert(b->begin(),b->end());
		return x;
	}

	set<Hradlo *> RekBunka::prunikvystupuSet (Hradlo* hr,RekBunka * suma, Hradlo * aktual){
		set<Hradlo *>::iterator itb;
		set<Hradlo *> x;
		bool ok=false;
		for(unsigned int i=0; i<hr->getohradlo()->size();i++){
			if(aktual==hr->getohradlo()->at(i)){
				x.insert(aktual);
				continue;
			}
			ok=false;
			for(unsigned int v=hr->getLevel()+1;v<suma->linie.size();v++){
				for(set<Hradlo *>::iterator itb=suma->linie[v].begin();itb!=suma->linie[v].end();itb++){
					if(hr->getLevel()>=(*itb)->getLevel()) continue;

					if(hr->getohradlo()->at(i)==(*itb)){
						ok=true;
						x.insert(hr->getohradlo()->at(i));

						break;
					}
				}
				if(ok) break;
			}
		}
		return x;
	}

	RekBunka RekBunka::soucetBunek (RekBunka * a,RekBunka * b){
		RekBunka x=RekBunka(a->linie.size());
		for(unsigned int i =0; i<a->linie.size();i++){
			if(a->linie[i].size()==0&&b->linie[i].size()==0) continue;
			x.linie[i]=soucetSet(&a->linie[i],&b->linie[i]);
		}
		return x;
	}

	set<Hradlo *> RekBunka::prunikSet (set<Hradlo*>  * a,set<Hradlo*> * b){
		set<Hradlo *> x;
		set<Hradlo *>::iterator itb,ita;
		if(a->size()==0||b->size()==0) return x;
		itb=b->begin();
		ita=a->begin();
		while(ita!=a->end()&&itb!=b->end()){
			if((*ita)==(*itb)){
				x.insert((*ita));
				ita++;
				itb++;
				continue;
			}
			if((*ita)<(*itb)){
				ita++;
				continue;
			}
			if((*ita)>(*itb)){
				itb++;
				continue;
			}

		}
		return x;
	}

	bool RekBunka::prazdna(){
		if(this->linie.size()==0)return true;


		if(linie.begin()->size()==0)return true; //prvni neni vyplnena

		return false;

	}
	void RekBunka::porovnej(RekBunka * nova,   Hradlo * aktual, list<RekonObj*> * rek){
		if(nova->prazdna()||this->prazdna()) return;
		set<Hradlo *>::iterator it;
		list<RekonObj *>::iterator itr;
		RekBunka pomoc;
		Hradlo * hr;
		set<Hradlo *> s,s2, v;
		for(unsigned int i =0; i<linie.size();i++){
			if((int)i==aktual->getLevel()){break;}
			s=prunikSet(&linie[i],&nova->linie[i]);
			if(s.size()==0){ //neni prunik
				s2=prunikSet(&linie[i-1],&nova->linie[i-1]);

				for(set<Hradlo*>::iterator ito=s2.begin();ito!=s2.end();ito++){

					hr=*ito;//rekonvergence vynika
					pomoc=soucetBunek(this,nova);
					v=prunikvystupuSet(hr,&pomoc,aktual);

					//ted musim zjistit zda uz tato rekonvergence neexituje
					bool vlozit=true;
					if(rek->size()!=0){
						itr=rek->begin();
						while(itr!=rek->end()&&(*itr)->ukonceni==aktual){//&&(*itr)->ukonceni==aktual
							if(stejneSet(&v,&(*itr)->vetveniSet)&&(*itr)->signal==hr){
								vlozit=false;
								break;
							}
							itr++;

						}

					}

					if(vlozit){
					  rek->push_front(new RekonObj(hr,v,aktual));
					}
				}

				break;
			}
		}



	}

	void RekBunka::sloucit(RekBunka * nova){

		for(unsigned int i =0; i<linie.size();i++){
			linie[i]=soucetSet(&linie[i],&nova->linie[i]);
		}

	}
	void RekBunka::pridejNaKonec( Hradlo * aktual){
		if(!prazdna()){
		 linie[aktual->getLevel()].insert(aktual);
		}
	}

	 RekBunka::~RekBunka(void){

	 }