	#include "stdafx.h"

using namespace std;
#include "../../Kernel/kernelincludes.h"

#include "Hradlo.h"
#include "RekonObj.h"
#include "RekBunka.h"
#include "RekonBunkaSeznam.h"



    RekonBunkaSeznam::RekonBunkaSeznam(){

	}
	RekonBunkaSeznam::RekonBunkaSeznam(int pocetvstupu, Hradlo * port, int poceturovni){
		RekBunka a= RekBunka(poceturovni); //nic jen se nafoukne
		RekBunka p = RekBunka(poceturovni,port);
		for(int i=0 ;i<pocetvstupu;i++){
			if(port->getiport()==i){
				this->seznam.push_back(p);
			}else{
			    this->seznam.push_back(a);
			}
		}
	}
	RekonBunkaSeznam::RekonBunkaSeznam(int pocetvstupu, int poceturovni){
		RekBunka a= RekBunka(poceturovni); //nic jen se nafoukne
		for(int i=0 ;i<pocetvstupu;i++){
			this->seznam.push_back(a);
		}
	}

	void  RekonBunkaSeznam::porovnej(RekonBunkaSeznam * rekbunSeznamA,RekonBunkaSeznam * rekbunSeznamB,Hradlo * aktual, list<RekonObj*> * listRekonvergenciNaPridani){
		for(unsigned int i=0;i<rekbunSeznamA->seznam.size();i++){
			rekbunSeznamA->seznam[i].porovnej(&rekbunSeznamB->seznam[i],aktual,listRekonvergenciNaPridani);
		}
	}

	void RekonBunkaSeznam::slouci(RekonBunkaSeznam * rekbunSeznam){
		for(unsigned int i=0;i<seznam.size();i++){
			seznam[i].sloucit(&rekbunSeznam->seznam[i]);
		}
	}

	vector< RekBunka > * RekonBunkaSeznam::getSeznam(){
		return &seznam;
	}

	void RekonBunkaSeznam::pridatHradlo(Hradlo * pridat){
		for(unsigned int i=0; i<seznam.size();i++){
			seznam[i].pridejNaKonec(pridat);
		}

	}
	RekonBunkaSeznam::~RekonBunkaSeznam(void){

	}

