#include "stdafx.h"
using namespace std;
#include <stdexcept>

#include "../../Kernel/kernelincludes.h"
#include  "Hradlo.h"
#include "Vstup.h"
Vstup::Vstup(){

}
bool complist (int first, int second){
   if (first>second) return true;
   return false;
}

void BubbleSort(vector<int> * p){//pro setrideni urovni vystupu, nic velkeho
	int pom;
	for (int i = p->size()-1; i >= 0; i--){
      for (int j = 1; j <= i; j++){
		  if (p->at(j-1) < p->at(j)){
			pom=p->at(j-1);
			p->at(j-1)=p->at(j);
			p->at(j)=pom;
		  }
	  }
	}
} 


Vstup::Vstup(int argc, char* argv[]){
	this->vypocetRekonvergence=true;
	this->pocetHradel=-1;
	this->pocetUrovniObvodu=-1;
	this->maxSirkaObvodu=-1;
	this->maxVetveni=-1;
	this->prumerVetveni=-1;
	this->latch=0;
	this->maxPocetVstupuHradla=2;
	this->hloubkaNavaznosti=1;
	this->pocetVstupu=-1;
	this->pocetVystupu=-1;
	this->log=true;
	this->model="Model";
	string err="";

	if(argc==2){//vstupni soubor
		for(int i=0;i<HTYPESIZE;i++){
			this->cetnost[i]=-1;
		}

	


		ifstream in;
		char line[256];
		string str;
		in.open(argv[1]);
		if (!in.is_open()){
			err="File ";
			err=err+argv[1]+" not open.";
			throw logic_error(err.c_str());
		}
		int ur;
		 while(!in.eof()){
			 in>>str;
			 if(str.c_str()[0]=='#'){
				 in.getline (line,256);
				 continue;
			 }
			 
			 if(str.c_str()[0]!='.'){
				 
				 err="Error in input file. Nunexpected line: "+str;
				 throw logic_error(err.c_str());
			 }
			 
			 //INV, XOR, NXOR, AND, OR, NAND, NOR
			 if(str==".model"){
				in>>model;
			 }else{
				 if(str==".vstupy"||str==".inputs"){
					 in>>pocetVstupu;
				 }else{
					 if(str==".vystupy"||str==".outputs"){
						 in>>pocetVystupu;
					 }else{
						 if(str==".levels"){
							 in>>pocetUrovniObvodu;
						 }else{
							 if(str==".maxvstuphradla"||str==".maxinputsnode"){
								 in>>maxPocetVstupuHradla;
							 }else{
								 if(str==".inv"){
									 in>>this->cetnost[0];
								 }else{
									 if(str==".xor"){
										 in>>this->cetnost[1];
									 }else{
										 if(str==".nxor"){
											 in>>this->cetnost[2];
										 }else{
											 if(str==".and"){
												 in>>this->cetnost[3];
											 }else{
												 if(str==".or"){
													 in>>this->cetnost[4];
												 }else{
													 if(str==".nand"){
														 in>>this->cetnost[5];
													 }else{
														 if(str==".nor"){
															 in>>this->cetnost[6];
														 }else{
															 if(str==".navaznost"||str==".maxlenghtsignals"){
																 in>>this->hloubkaNavaznosti;
																 if(this->hloubkaNavaznosti<1){
																	err="Error inputs parametr. : maxlenghtsignals is "+this->hloubkaNavaznosti;
																	throw logic_error(err.c_str());

																 }
															 }else{
																 if(str==".pocethradel"||str==".nodes"){
																	in>>this->pocetHradel;
																	}else{
																		if(str==".log"){
																			in>>this->log;
																		}else{
																			if(str==".maxvetveni"||str==".maxsignalfanout"){
																				in>>this->maxVetveni;
																			}else{
																				if(str==".prumervetveni"||str==".averagesignalfanout"){
																					in>>this->prumerVetveni;
																				}else{
																					if(str==".latch"){
																						in>>this->latch;
																					}else{
																						if(str==".urovnevystupu"||str==".leveloutput"){
																							for(int k=0; k<pocetVystupu;k++){
																								in>>ur;
																								urovneVystupu.push_back(ur);
																							}
																						}else{
																							if(str==".urovnelatch"||str==".levellatch"){
																								for(int k=0; k<latch;k++){
																									in>>ur;
																									urovneLatch.push_back(ur);
																								}
																							}else{
																								if(str==".reconverg"){
																									in>>ur;
																									if(ur==0){
																										vypocetRekonvergence=false;
																									}else{
																										vypocetRekonvergence=true;
																									}
																								}else{
																								    err="Error inputs parametr. Unexpected line: "+str;
																								   throw logic_error(err.c_str());
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																 }
															 }
														 }
													 }
												 }
											 }
										 }
									 }
								 }
							 }
						 }
					 }
				 }
			 }

		 }

		 if(pocetHradel!=-1){
		 //setridim a doplnim hodnty
			 if(urovneVystupu.size()>0){
				 BubbleSort(&urovneVystupu);
			 }else{
				 for(int i=0; i<pocetVystupu;i++){
					 urovneVystupu.push_back(pocetUrovniObvodu);
				 }
			 }

			 if(urovneLatch.size()>0){
				 BubbleSort(&urovneLatch);
			 }else{
				 for(int i=0; i<latch;i++){
					 urovneLatch.push_back(pocetUrovniObvodu);
				 }
			 }
		 }else{
			 urovneVystupu.clear();
			 urovneLatch.clear();
			for(int i=0; i<latch;i++){
				urovneLatch.push_back(pocetUrovniObvodu);
			}
			for(int i=0; i<pocetVystupu;i++){
				urovneVystupu.push_back(pocetUrovniObvodu);
			}
		 }
		 urovnedohromady.insert(urovnedohromady.begin(),urovneLatch.begin(),urovneLatch.end());
		 urovnedohromady.insert(urovnedohromady.begin(),urovneVystupu.begin(),urovneVystupu.end());
		 BubbleSort(&urovnedohromady);
		 if(urovnedohromady[0]!=pocetUrovniObvodu){
			 err="Chyba... spatne nastavene urovne latch nebo vystupu.";
			throw logic_error(err.c_str());
		 }

		 hloubkaNavaznosti=min(pocetUrovniObvodu,hloubkaNavaznosti);
		 
		 		string newmodel="" ;
		 for(unsigned int i=0; i<model.size();i++){
			if(model.c_str()[i]=='/'){
				newmodel=newmodel+"_";
			}else{
				newmodel=newmodel+model.c_str()[i];
			}
		}

		model=newmodel;

		 for(int i=0;i<HTYPESIZE;i++){
			if(this->cetnost[i]<0){
				this->cetnost[i]=5;
			}
		}
		 //prictu pocet latch do vstupu a vystupu
		 this->pocetVstupu+=this->latch;
		 this->pocetVystupu+=this->latch;
		 if(cetnost[3]==0&&cetnost[4]==0&&cetnost[5]==0&&cetnost[6]==0){
			 maxPocetVstupuHradla=2;
		 }
		 if(pocetUrovniObvodu==-1||pocetVstupu==-1||pocetVystupu==-1){
			err="Error. Bad parametr inputs, outputs or levels.";
			throw logic_error(err.c_str());
		 }

		 if(this->pocetVstupu==0||this->pocetVystupu==0||this->pocetUrovniObvodu<1||this->maxPocetVstupuHradla<2){
		     throw logic_error("Error. Bad parametr inputs, outputs, levels or max. inputs node.");
		 }
		 return;
	}

	/*if(argc==11||argc==10){
		this->vypocetRekonvergence=false;
		this->latch=0;
		//4 1 10 2 0 1 1 200000 model 30
		cout<<"Parametry primo."<<endl;
		this->pocetVstupu=atoi (argv[1]);
		this->pocetVystupu= atoi (argv[2]);
		this->pocetUrovniObvodu=atoi (argv[3]);
		this->maxPocetVstupuHradla= atoi (argv[4]);
		if(argv[5][0]=='1'){
			this->log=true;
		}else{
			this->log=false;
		}
		//nastaveni cetnosti; yatim napevno
		this->cetnost[0]=5;

		this->cetnost[3]=5;
		this->cetnost[4]=5;
		this->cetnost[5]=5;
		this->cetnost[6]=5;

		if(argv[6][0]=='1'){
			this->cetnost[1]=5;
			this->cetnost[2]=5;
		}else{
			cout<<"XOR a NXOR zakazany."<<endl;
			this->cetnost[1]=0;
			this->cetnost[2]=0;
		}


		
		this->hloubkaNavaznosti=atoi (argv[7]);
		this->pocetHradel=atoi (argv[8]);
		this->model=argv[9];
		if(argc==11){
			this->maxSirkaObvodu=atoi (argv[10]);
		}

		 //setridim a doplnim hodnty
		 if(urovneVystupu.size()>0){
			 BubbleSort(&urovneVystupu);
		 }else{
			 for(int i=0; i<pocetVystupu;i++){
				 urovneVystupu.push_back(pocetUrovniObvodu);
			 }
		 }

		 if(urovneLatch.size()>0){
			 BubbleSort(&urovneLatch);
		 }else{
			 for(int i=0; i<latch;i++){
				 urovneLatch.push_back(pocetUrovniObvodu);
			 }
		 }
		 urovnedohromady.insert(urovnedohromady.begin(),urovneLatch.begin(),urovneLatch.end());
		 urovnedohromady.insert(urovnedohromady.begin(),urovneVystupu.begin(),urovneVystupu.end());
		 BubbleSort(&urovnedohromady);
		 if(urovnedohromady[0]!=pocetUrovniObvodu){
			 err="Chyba... spatne nastavene urovne latch nebo vystupu.";
			throw logic_error(err.c_str());
		 }
		 this->pocetVstupu+=this->latch;
		 this->pocetVystupu+=this->latch;
		 //---------------------------------------------------------

	}else{
		throw logic_error("Chyba vstupu.");

	}
	*/

	throw logic_error("Bad input parameters.");
}
